; this is a first draft (finally had the time to do one)
; updates will follow (with better and updated comments ;-))
;
; nasm -f bin -o entry.com entry.asm
; 
; by Gongo / Green (aka Dimitri Smits)


[section .text]

org 100h

; some adresses in equ style
; place to put the palette and the points into
COLORMAP equ 0300h   ; size is 3*256 bytes = 300h bytes
; 512 is the assumed maximum nr of points
POINTS   equ 0600h   ; assumed maximum nr of points
; the distance texture map is 128*256 bytes big = 32K
; org = 00A00h here
DISTANCE equ 00A00h

; -- preserve state so you can use it later on (save all general purpose registers)
;    this saves a lot on pre-initialising later on

	push cx    ; 1b
	mov al, 13h  ; 2b
	int 10h    ; 2b
	
; -- first get the commandline filename (param 1) and make it a ASCIIZ string

	mov ah, 0fh     ; 2b
	mov dx, 5ch     ; 3b
	int 21h         ; 2b  
	inc ax          ; 1b
	mov byte [06ah], al  ; 3b

; do the loading and precalcing here (max 60 bytes!)

; -- open file


; ax contains the filehandle now, so move it to bx for reading (ah is 0, al= handle)
	mov di, COLORMAP ; 3b
	push di      ; 1b

@@read_value:
	salc    ; 1b
@start_file_reading_loop:
	xchg bp, ax   ; 1b
	mov ah, 14h   ; 2b
	int 21h       ; 2b
	xchg bp, ax   ; 1b
        mov ah, [80h]   ; 3b
	sub ah, 30h     ; 3b
	js short @proces_special_chars ; 2b
	xchg ah, al   ; 2b
	aad           ; 1b
	jmp short @start_file_reading_loop  ; 2b
@proces_special_chars:
	jnp short @0ah_or_1ah  ; 2b
	stosb         ; 1b
@0ah_or_1ah:	
	and ah, 1bh   ; 3b
	jnp short @@read_value  ; 2b

	mov dx, 3c8h     ; 3b
	pop si           ; 1b
	out dx, al       ; 1b
	
	mov ah, 80h      ; 2b
	
	xchg ax, di      ; 1b
	mov cx, SI       ; 2b
	inc dx           ; 1b
	rep outsb        ; 2b
	
	xchg ax, si      ; 1b

@textureYLoop:

@textureXLoop:
	
	dec di               ; 1b
	
@findNearest:
	mov bx, 600h         ; 3b
	mov bp, sp           ; 2b
	
@findNearestLoop:
	mov dx, di           ; 2b
	shr dl, 1            ; 2b
	mov ax, [bx]         ; 2b
	xchg al, dl          ; 2b

@distanceLoop:
	sub al, ah           ; 2b

	test al, 40h         ; 2b
	jz short @skipNegate ; 2b
	neg ax               ; 2b
@skipNegate:          
	and al, 7fh          ; 2b
	
@ok:
	mul al  ; ax = al*al ; 2b
	xchg ax, dx       ; 1b
	inc bx            ; 1b
	test bl, 1        ; 3b
	jnz short @distanceLoop ; 2b
	add ax, dx        ; 2b
	cmp bp, ax        ; 2b
	jbe short @skipMinDistSwitch ; 2b
	xchg ax, bp       ; 1b
@skipMinDistSwitch: 
	cmp bx, si        ; 2b
	jb short @findNearestLoop    ; 2b
	xchg ax, bp       ; 1b
	mov [di + 9FFh], ax ; 4b
	cmp ax, cx        ; 2b
	jb short @skipMaxDistSwitch  ; 2b
	xchg ax, cx       ; 1b

@skipMaxDistSwitch:
	dec di            ; 1b
	jnz @textureYLoop ; 2b

	push word 0a000h  ; 3b	
	pop es  	  ; 1b

	xor si, si        ; 2b
	
	pop bp            ; 1b

@draw_loop:

@draw_inner:
	mov ax, di        ; 2b
	mov bx, 320       ; 3b
	xor dx, dx        ; 2b
	div bx            ; 2b
	
	xchg ax, bx       ; 1b
	xchg bh, dl       ; 2b
	shl bx, 1         ; 2b
	shr bh, 1	  ; 2b
	
	mov ax, [bx + 0a00h] ; 4b
	mul bp            ; 2b
	div cx            ; 2b
	
	xor ax, si        ; 2b
	
	stosb             ; 1b
	test di, di       ; 2b
	jnz short @draw_inner ; 2b
	
	xor ax, ax   ; 2b
	int 16h	     ; 2b
	
	not si       ; 2b
	
	cmp al, 32   ; 2b
	je short @draw_loop ;2b
	
	mov ax, 03h  ; 3b
	int 10h	     ; 2b
		
        ret          ; 1b
       
[section .data]

[section .bss]
